--the greatest weapon in game
--by minenice

--apparently this makes shit faster? wtf?
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local FRACBITS = FRACBITS
local MAXSKINCOLORS = MAXSKINCOLORS
local ANG1 = ANG1
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_throwdir = k_throwdir

--item flags
local XIF_POWERITEM = 1 --is power item (affects final odds)
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_LOCKONUSE = 8 --locks the item slot when the item is used, slot must be unlocked manually by setting player.xItemData.xItem_itemSlotLocked to false
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --map hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon changes depending on the item amount (animation frames become amount frames)

freeslot(
	"MT_PICKEL_AXE",
	"MT_PICKEL_AXE_DEAD",

	"S_PICKEL_AXE",
	"S_PICKEL_AXE_RAISE",
	"S_PICKEL_AXE_SWING",
	"S_PICKEL_AXE_DEAD",
	"S_PICKEL_AXE_BREAK",
	"S_PICKEL_SWEEP",
	"S_PICKEL_PARTICLE",

	"SPR_PKAX",

    "sfx_pkaxu1",
	"sfx_pkaxu2",
	"sfx_pkaxu3",
	"sfx_pkaxu4",
	--breaks
	"sfx_pkaxdt",
	--hit
	"sfx_pkaxh0",
	"sfx_pkaxh1",
	"sfx_pkaxh2",
	--hit knockback
	"sfx_pkaxh3",
	"sfx_pkaxh4",
	--hit crit
	"sfx_pkaxh5",
	"sfx_pkaxh6"
)

local ax
local function spawnPickelBreakParticle(mo)
	for i = 1, 12 do
		ax = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_PICKEL_AXE_DEAD)
		ax.momx = FixedMul(P_RandomFixed() - FRACUNIT/2, 6*mapobjectscale)
		ax.momy = FixedMul(P_RandomFixed() - FRACUNIT/2, 6*mapobjectscale)
		ax.momz = 4*P_MobjFlip(mo)*mapobjectscale
		ax.scale = FixedMul(3*mo.scale/2, P_RandomFixed() + FRACUNIT/2)

		ax.state = S_PICKEL_PARTICLE
		ax.frame = Q + (i%4)
	end
end

function A_PickelAxeDeath(mo)
	--breaking particles
	spawnPickelBreakParticle(mo)
end

local function generateHFForPlayer(p)
    if p and p.valid and p.mo and p.mo.valid then
        return {{p.name, p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
    else
        return {{}, {}}
    end
end

mobjinfo[MT_PICKEL_AXE] = {
	doomednum = -1,
    spawnstate = S_PICKEL_AXE_RAISE,
	deathstate = S_NULL,
    spawnhealth = 1000,
    radius = 12*FRACUNIT,
    height = 8*FRACUNIT,
    flags = MF_SPECIAL|MF_NOGRAVITY|MF_SLIDEME|MF_DONTENCOREMAP
}

mobjinfo[MT_PICKEL_AXE_DEAD] = {
	doomednum = -1,
    spawnstate = S_PICKEL_AXE_DEAD,
    spawnhealth = 1000,
    radius = 1,
    height = 1,
    flags = MF_DONTENCOREMAP
}

states[S_PICKEL_AXE] = {
	sprite = SPR_PKAX,
	frame = FF_PAPERSPRITE|A,
	tics = -1,
	nextstate = S_PICKEL_AXE
}

states[S_PICKEL_AXE_SWING] = {
	sprite = SPR_PKAX,
	frame = FF_PAPERSPRITE|C,
	tics = TICRATE/3,
	nextstate = S_PICKEL_AXE_RAISE
}

states[S_PICKEL_AXE_DEAD] = {
	sprite = SPR_PKAX,
	frame = FF_ANIMATE|A,
	tics = 2*TICRATE/3,
	nextstate = S_PICKEL_AXE_BREAK,
	var1 = 7,
	var2 = 1
}

states[S_PICKEL_AXE_BREAK] = {
	sprite = SPR_NULL,
	frame = A,
	tics = 2,
	action = A_PickelAxeDeath,
	nextstate = S_NULL
}

states[S_PICKEL_AXE_RAISE] = {
	sprite = SPR_PKAX,
	frame = FF_PAPERSPRITE|A,
	tics = TICRATE - (TICRATE/3),
	nextstate = S_PICKEL_AXE
}

states[S_PICKEL_SWEEP] = {
	sprite = SPR_PKAX,
	frame = FF_ANIMATE|FF_PAPERSPRITE|I,
	tics = 7,
	nextstate = S_NULL,
	var1 = 7,
	var2 = 1
}

states[S_PICKEL_PARTICLE] = {
	sprite = SPR_PKAX,
	frame = Q,
	tics = 3*TICRATE/4,
	nextstate = S_NULL
}

local axMaxUses = 4
--intentionally relatively small
--scale based on the inverse of the player actual speed stat
--because *someone* out there decided it was a good idea to have speed boosts scale with the (singular) speed stat
--(I miss https://www.mariowiki.com/Mario_Kart_7_in-game_statistics#Statistics_translation_tables)
--hell Tour doesn't even have the per-kart speed stat (and when it used to it was a bad idea!)
local axSpeedBoostMin = 24*FRACUNIT/100
local axSpeedBoostMax = 17*FRACUNIT/100
--intentionally relatively large
--this is so players can do quick micro-adjustments when going for someone's ass
--no scaling since players with less weight need all the help they can get
local axAccelBoost = 150*FRACUNIT/100

local function ClassPlayer()
	return {
		axUses = axMaxUses,
		axVisualMo = nil,
		hadItem = false,
		blink = false
	}
end

local function K_FlipFromObject(mo, master)
	mo.eflags = (mo.eflags & ~MFE_VERTICALFLIP)|(master.eflags & MFE_VERTICALFLIP)
	mo.flags2 = (mo.flags2 & ~MF2_OBJECTFLIP)|(master.flags2 & MF2_OBJECTFLIP)

	if (mo.eflags & MFE_VERTICALFLIP) then
		mo.z = $ + (master.height - FixedMul(master.scale, mo.height))
	end
end

local px, py, pz
local pdat
local ang
local p
local function spawnPickelAxe(target)
	if target.player then
		ang = target.player.frameangle
	else
		ang = target.angle
	end
	px = P_ReturnThrustX(nil, ang - (45*ANG1), target.radius)
	py = P_ReturnThrustY(nil, ang - (45*ANG1), target.radius)
	pz = target.z + P_MobjFlip(target)*target.height/8
	ax = P_SpawnMobj(target.x + px, target.y + py, pz, MT_PICKEL_AXE)
	ax.target = target
	ax.scale = 3*target.scale/2
	
	ax.angle = ang + (35*ANG1)

	return ax
end

local function spawnPickelCritParticle(mo, inflictor)
	for i = 1, 12 do
		ax = P_SpawnMobj(mo.x + FixedMul(P_RandomFixed() - FRACUNIT/2, mo.radius), 
			mo.y + FixedMul(P_RandomFixed() - FRACUNIT/2, mo.radius), mo.z + P_MobjFlip(mo)*mo.height/2, MT_THOK)
			
		ax.state = S_PICKEL_PARTICLE
		ax.frame = U

		ax.momx = FixedMul(P_RandomFixed() - FRACUNIT/2, 8*mapobjectscale)
		ax.momy = FixedMul(P_RandomFixed() - FRACUNIT/2, 8*mapobjectscale)
		ax.momz = FixedMul(P_RandomFixed() - FRACUNIT/2, 8*mapobjectscale)
		ax.scale = FixedMul(3*mo.scale, P_RandomFixed() + FRACUNIT/2)

		mo.tics = TICRATE/4
	end
end

local function spawnPickelHitParticle(mo, inflictor)
	for i = 1, 4 do
		ax = P_SpawnMobj(mo.x + 2*FixedMul(P_RandomFixed() - FRACUNIT/2, mo.radius), 
			mo.y + 2*FixedMul(P_RandomFixed() - FRACUNIT/2, mo.radius), mo.z + P_MobjFlip(mo)*mo.height, MT_THOK)

		ax.state = S_PICKEL_PARTICLE
		ax.frame = V

		ax.momz = -2*P_MobjFlip(mo)*mapobjectscale
		ax.scale = 5*mo.scale/2
	end
end

local scoremultiply = 1
local function pickelAxeSpecial(s, t)
	if s.state == S_PICKEL_AXE_SWING then
		--hurt opponents
		if t and t.health and t.player and t ~= s.target then
			if (t.player.kartstuff[k_invincibilitytimer] > 0 or t.player.kartstuff[k_growshrinktimer] > 0 
				or t.player.powers[pw_flashing] > 0 or t.player.kartstuff[k_spinouttimer] > 0) then
				K_DoInstashield(t.player)
				return true
			else
				if (s.target.player.kartTeam ~= nil and t.player.kartTeam ~= nil) and s.target.player.kartTeam == t.player.kartTeam then 
					K_DoInstashield(t.player)
					return true
				end
				--axe hits do wipeout
				K_SpinPlayer(t.player, s.target, 1, s)

				--emulate the cleaving forcing shields on cooldown by putting target's item on cooldown
				xItemLib.func.xItem_setPlayerItemCooldown(t.player, TICRATE*3)

				if s.target.player then
					spawnPickelHitParticle(t, s)
					if s.target.player.kartstuff[k_sneakertimer] then
						--sprint attack, knock back target
						t.momx = $ + s.target.momx
						t.momy = $ + s.target.momy
						S_StartSound(t, sfx_pkaxh3 + leveltime%2)
					elseif s.target.momz*P_MobjFlip(s.target) < 0 then
						--crit, 1.5x longer spinout
						t.player.kartstuff[k_spinouttimer] = 3*$/2
						S_StartSound(t, sfx_pkaxh0)
						S_StartSound(t, sfx_pkaxh5 + leveltime%2)
						spawnPickelCritParticle(t, s)
					else
						--regular hit, don't do anything special
						S_StartSound(t, sfx_pkaxh0)
						S_StartSound(t, sfx_pkaxh1 + leveltime%2)
					end

					--extra crossmod stuff
					if (hitfeed) then
						local source = generateHFForPlayer(s.target.player)
						local victim = generateHFForPlayer(t.player)
						HF_SendHitMessage(source, victim, "H_XIPKAX", s.target.skincolor)
					end
					if fesScoring then
						FES_scoring_rewardPlayerAction(s.target.player, "xitem_pickelaxe")
					end
				end
			end
		end
	end
	--make it not kill itself
	return true
end

local speed, dist
local function spawnSweep(mo)
	if mo.target then
		local sw = P_SpawnMobj(mo.x + P_ReturnThrustX(nil, mo.angle, 3*mo.radius/2), 
			mo.y + P_ReturnThrustY(nil, mo.angle, 3*mo.radius/2), mo.z, MT_THOK)
		sw.state = S_PICKEL_SWEEP
		sw.scale = 3*mo.scale/2
		speed = R_PointToDist2(0, 0, mo.target.momx, mo.target.momy)
		sw.momx, sw.momy, sw.momz = P_ReturnThrustX(nil, mo.target.angle, speed), P_ReturnThrustY(nil, mo.target.angle, speed), mo.target.momz/2
		sw.angle = mo.angle + 90*ANG1
		K_FlipFromObject(sw, mo)
	end
end

local function pickelAxeThinker(mo)
	if not (mo.target and mo.target.valid and mo.target.health) then 
		local dt = P_SpawnMobj(mo.x, mo.y, mo.z, MT_PICKEL_AXE_DEAD)
		dt.momz = 12*mapobjectscale
		S_StartSound(dt, sfx_pkaxdt)
		P_KillMobj(mo)
		return
	end
	if mo.state == S_PICKEL_AXE_SWING then
		--spin around user and spawn the sweep
		mo.scale = 7*mo.target.scale/2
		mo.flags = $ & ~(MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING)
		ang = mo.target.angle

		--todo: use lerp library to make shit spin
		local aoff = TableLerp.flerp(mo.tics, TICRATE/3, (360-25), -15)*ANG1
		A_GhostMe(mo)
		px = mo.target.x + P_ReturnThrustX(nil, ang + aoff, mo.target.radius + 7*mo.radius/2)
		py = mo.target.y + P_ReturnThrustY(nil, ang + aoff, mo.target.radius + 7*mo.radius/2)
		pz = P_MobjFlip(mo.target)*mo.target.height/8
		mo.angle = ang + aoff

		if mo.tics == (TICRATE/3 - 1) or mo.tics == ((TICRATE/3)/2 - 1) then
			spawnSweep(mo)
		end

		if mo.tics <= 1 and mo.target.player then
			pdat.blink = false
			if pdat.axUses == 0 then
				mo.target.player.kartstuff[k_itemamount] = $-1
				if mo.target.player.kartstuff[k_itemamount] then
					mo.target.player.pickelAxeData = ClassPlayer()
					mo.target.player.pickelAxeData.axVisualMo = spawnPickelAxe(p.mo)
				else
					mo.target.player.pickelAxeData = nil
				end
				local dt = P_SpawnMobj(mo.target.x, mo.target.y, mo.target.z, MT_PICKEL_AXE_DEAD)
				dt.momz = P_MobjFlip(mo.target)*12*mapobjectscale
				dt.momx, dt.momy = mo.target.momy/4, mo.target.momx/4
				S_StartSound(dt, sfx_pkaxdt)
				P_KillMobj(mo)
			end
		end
	else
		--follow the user
		mo.scale = 3*mo.target.scale/2
		mo.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
		if mo.target.player then
			ang = mo.target.player.frameangle
		else
			ang = mo.target.angle
		end
		mo.angle = ang + (35*ANG1)
		px = mo.target.x + P_ReturnThrustX(nil, ang - (45*ANG1), mo.target.radius)
		py = mo.target.y + P_ReturnThrustY(nil, ang - (45*ANG1), mo.target.radius)
		if mo.state == S_PICKEL_AXE_RAISE then
			pz = P_MobjFlip(mo.target)*TableLerp.outQuart(mo.tics, TICRATE/2, mo.target.height/3 + mapobjectscale, mo.target.height/12)
		else
			pz = P_MobjFlip(mo.target)*mo.target.height/3
		end
	end
	if mo and mo.valid and mo.health and mo.target and mo.target.valid then
		--it's ok to see this while invisible
		K_FlipFromObject(mo, mo.target)
		mo.flags = $ | MF_NOCLIPTHING -- temporarily make them noclip other objects so they can't hit anyone while in the player

		--really weird shit here that barely works
		if (P_MobjFlip(mo) > 0) then
			P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z - 1)
        else
            P_MoveOrigin(mo, mo.target.x, mo.target.y, mo.target.z + mo.target.height - mo.height + 1)
        end
		
		mo.momx = FixedMul(cos(R_PointToAngle2(mo.x, mo.y, px, py)), R_PointToDist2(mo.x, mo.y, px, py))
		mo.momy = FixedMul(sin(R_PointToAngle2(mo.x, mo.y, px, py)), R_PointToDist2(mo.x, mo.y, px, py))
		-- P_SetObjectMomZ(mo, pz - mo.z)
		mo.flags = $ & ~MF_NOCLIPTHING
		if not P_TryMove(mo, mo.target.x + mo.momx, mo.target.y + mo.momy, true) then
			P_SlideMove(mo, true)
		end

		--mo.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
		if mo.target.standingslope then
			mo.z = P_GetZAt(mo.target.standingslope, mo.x, mo.y) + pz
		else
			mo.z = mo.target.z + pz
		end
		
		mo.momx, mo.momy = 0, 0
	end
end

local function axeThingCollide(mo, tmo)
	if mo.state != S_PICKEL_AXE_SWING then return false end
	if (mo.z > tmo.z + tmo.height) then
		return false
	elseif (mo.z + mo.height < tmo.z) then
		return false
	end
	if (tmo.type == MT_ORBINAUT or tmo.type == MT_JAWZ or tmo.type == MT_JAWZ_DUD
			or tmo.type == MT_ORBINAUT_SHIELD or tmo.type == MT_JAWZ_SHIELD
			or tmo.type == MT_BANANA or tmo.type == MT_BANANA_SHIELD
			or tmo.type == MT_BALLHOG or tmo.type == MT_SINK or (tmo.flags & MF_MISSILE)) then

		if (tmo.eflags & MFE_VERTICALFLIP) then
			tmo.z = $-tmo.height
		else
			tmo.z = $+tmo.height
		end

		S_StartSound(tmo, tmo.info.deathsound)
		P_KillMobj(tmo, mo, mo.target)

		tmo.momz = 8*mapobjectscale
		P_InstaThrust(tmo, R_PointToAngle2(mo.x, mo.y, tmo.x, tmo.y)+90*ANG1, 16*mapobjectscale)

		P_SpawnMobj((tmo.x + mo.x)/2, (tmo.y + mo.y)/2, (tmo.z + mo.z)/2, MT_ITEMCLASH)
	elseif (tmo.type == MT_SSMINE_SHIELD or tmo.type == MT_SSMINE) then
		P_KillMobj(tmo, mo, mo.target)
	elseif (tmo.type == MT_SMK_ICEBLOCK) then
		if tmo.health then
			P_KillMobj(tmo, mo, mo.target)
		end
	elseif tmo.type ~= MT_PLAYER and (tmo.flags & MF_SHOOTABLE) then
		if tmo.health then
			spawnPickelHitParticle(tmo, mo)
			S_StartSound(tmo, sfx_pkaxh0)
			if mo.target and mo.target.valid and mo.target.momz*P_MobjFlip(mo.target) < 0 then
				spawnPickelCritParticle(tmo, mo)
				S_StartSound(tmo, sfx_pkaxh5 + leveltime%2)
			else
				S_StartSound(tmo, sfx_pkaxh1 + leveltime%2)
			end
			P_DamageMobj(tmo, mo, mo.target, 1)
		end
	end
end

local function playerThink(p)
	if p.kartstuff[k_itemtype] == xItemLib.xItemNamespaces.XITEM_SAMPLER_PICKELAXE and p.kartstuff[k_itemamount] then
		if p.pickelAxeData then
			pdat = p.pickelAxeData
			pdat.hadItem = true
			if (p.mo and p.mo.valid and p.mo.health) and not (pdat.axVisualMo and pdat.axVisualMo.valid and pdat.axVisualMo.health) then
				pdat.axVisualMo = spawnPickelAxe(p.mo)
			end
		else
			p.pickelAxeData = ClassPlayer()
		end
	elseif p.pickelAxeData and p.pickelAxeData.hadItem then
		if p.pickelAxeData.axVisualMo and p.pickelAxeData.axVisualMo.valid then P_KillMobj(p.pickelAxeData.axVisualMo) end
		p.pickelAxeData = nil
	end
end

local name = "xItem_PickelAxe"
local boostPower, pdis, spd
local function playerMobjThink(mo)
	if not mo.player then return end
	--battle always gives the full buff
	if G_BattleGametype() then
		if mo.player.kartstuff[k_itemtype] == xItemLib.xItemNamespaces.XITEM_SAMPLER_PICKELAXE then
			spd = min(max(TableLerp.flerp(mo.player.kartspeed - 1, 8, axSpeedBoostMin, axSpeedBoostMax), axSpeedBoostMin), axSpeedBoostMax)
			mo.player.kartstuff[k_speedboost] = max($, spd)
			mo.player.kartstuff[k_accelboost] = max($, axAccelBoost)
		end
	else
		boostPower, pdis, spd = 0, 0, axSpeedBoostMin
		if mo.player.kartstuff[k_itemtype] == xItemLib.xItemNamespaces.XITEM_SAMPLER_PICKELAXE then
			for p in players.iterate do
				if p and p.mo and (not p.spectator) and (p.kartstuff[k_position] == 1) and p.kartstuff[k_position] < mo.player.kartstuff[k_position] then
					pdis = (7*(R_PointToDist2(0, mo.x, R_PointToDist2(mo.y, mo.z, p.mo.y, p.mo.z), p.mo.x) / mapobjectscale)/8) + (280 * mo.player.kartstuff[k_position])
				end
			end
			boostPower = max(min(TableLerp.flerp(pdis / 4, 64*20, 0, FRACUNIT), FRACUNIT), 0)
			spd = min(max(TableLerp.flerp(mo.player.kartspeed - 1, 8, axSpeedBoostMin, axSpeedBoostMax), axSpeedBoostMin), axSpeedBoostMax)
			if not BLib then
				--fallback behaviour if no stacking
				if mo.player.kartstuff[k_boostpower] >= 0 then
					mo.player.kartstuff[k_speedboost] = max($, FixedMul(spd, boostPower))
					mo.player.kartstuff[k_accelboost] = max($, FixedMul(axAccelBoost, boostPower))
				end
				return
			end
			
			BLib.SetBoost(mo.player, name, FixedMul(spd, boostPower),
				FixedMul(axAccelBoost, boostPower))
		else
			if not BLib then return end
			BLib.SetBoost(mo.player, name, 0, 0)
		end
	end
end

local function axeAttack(p)
	pdat = p.pickelAxeData

	xItemLib.func.xItem_setPlayerItemCooldown(p, TICRATE)
	S_StartSound(pdat.axVisualMo, sfx_pkaxu1 + (leveltime%4))
	pdat.axVisualMo.state = S_PICKEL_AXE_SWING
	pdat.axUses = max($-1, 0)

	pdat.blink = true
	if p.mo then
		K_PlayAttackTaunt(p.mo)
	end
end

local function getAxe(p, i)
	p.pickelAxeData = ClassPlayer()
	p.pickelAxeData.axVisualMo = spawnPickelAxe(p.mo)
	xItemLib.func.xItem_setPlayerItemCooldown(p, TICRATE)
end

local function useAxe(p, cmd)
	if p.pickelAxeData then
		axeAttack(p)
	end
end

local function drawAxe(v, p, c)
	p.xItemData.xItem_timerBar = p.pickelAxeData.axUses
	p.xItemData.xItem_maxTimerBar = axMaxUses
    xItemLib.func.hudDrawItem(v, p, c, nil, p.pickelAxeData.blink and 2 or nil)
end


addHook("ThinkFrame", function()
	for p in players.iterate do
		playerThink(p)
	end
end)
addHook("MobjMoveCollide", axeThingCollide, MT_PICKEL_AXE)
addHook("MobjThinker", pickelAxeThinker, MT_PICKEL_AXE)
addHook("TouchSpecial", pickelAxeSpecial, MT_PICKEL_AXE)
addHook("MobjThinker", playerMobjThink, MT_PLAYER)

if fesScoring then
	FES_scoring_addAction("xitem_pickelaxe", "Stone Axe Accuracy", 25)
end

if xItemLib then
	xItemLib.func.addItem{"XITEM_SAMPLER_PICKELAXE", 
		"Stone Axe", 
		"K_ITPKAX", 
		"K_ISPKAX", 
		XIF_COOLDOWNONSTART, 
		{0, 0, 5, 4, 2, 1, 0, 0, 0, 0}, 
		{5, 1},	--could be fun in battle
		getAxe, 
		useAxe, 
		drawAxe, 
		false, 
		false, 
		{0, {SPR_XITS, 7}}, 
		true,
		nil,
		nil
    }
	
	xItemLib.func.setXItemModData("XITEM_DESCRIPTIONS", "XITEM_SAMPLER_PICKELAXE", {
		tipDescription1 = "Equip a Stone Axe to strike opponents",
		tipDescription2 = "Attacks disable target's items for a while",
		tipUsage1 = "Usable up to four times",
		tipUsage2 = "Press \130Fire\128 to use",
	})
end
